#  grt4p.defn.tcl

proc {Add_GRT 4P_Module} {name server addressdata} {
   global CurrentVMEServer

   set moduleID [last [split $name #]]

#    split up address information into 
   set addressinfo [split $addressdata :]
   set A16addrbase [first $addressinfo]
   set A24addrbase [second $addressinfo]
   set A32addrbase [third $addressinfo]
#   set interruptlevel [fourth $addressinfo]
#   set interruptvector [fifth $addressinfo]

   set CurrentVMEServer  $server
 
   set i 0
   foreach ch {A B C D} {
      define-vme-register $name xVME Ch$ch.DataFiFo "-a$A32addrbase -w32 -o[format "0x%x" [expr 0x2000 + $i]] -pro -d16 -zx"

      define-vme-register $name xVME Ch$ch.DPP_CSR  "-a$A32addrbase -w32 -o[format "0x%x" [expr 0x00 + $i]] -prw -d16 -zx -i0xf"
      for {set b 0} {$b < 16} {incr b} {
        define-vme-register $name xVME Ch$ch.DPP_CSR.b$b  "-a$A32addrbase -w32 -o[format "0x%x" [expr 0x00 + $i]] -prw -d16 -l1 -b$b -zd"
      }
      define-vme-register $name xVME Ch$ch.DPP_Wptr  "-a$A32addrbase -w32 -o[format "0x%x" [expr 0x02 + $i]] -pro -d16 -zx"
      define-vme-register $name xVME Ch$ch.DPP_Rptr  "-a$A32addrbase -w32 -o[format "0x%x" [expr 0x04 + $i]] -pro -d16 -zx"
      define-vme-register $name xVME Ch$ch.DPP_Reg4  "-a$A32addrbase -w32 -o[format "0x%x" [expr 0x06 + $i]] -prw -d16 -zx"
      define-vme-register $name xVME Ch$ch.DPP_Reg5  "-a$A32addrbase -w32 -o[format "0x%x" [expr 0x08 + $i]] -prw -d16 -zx"
      define-vme-register $name xVME Ch$ch.DPP_Reg6  "-a$A32addrbase -w32 -o[format "0x%x" [expr 0x0a + $i]] -prw -d16 -zx"

      define-vme-register $name xVME Ch$ch.ADC_Ctrl    "-a$A32addrbase -w32 -o[format "0x%x" [expr 0x1000 + $i]] -prw -d16 -zx -i0"
      for {set b 0} {$b < 16} {incr b} {
        define-vme-register $name xVME Ch$ch.ADC_Ctrl.b$b  "-a$A32addrbase -w32 -o[format "0x%x" [expr 0x1000 + $i]] -prw -d16 -l1 -b$b -zd"
      }
      define-vme-register $name xVME Ch$ch.ADC_PreTrig "-a$A32addrbase -w32 -o[format "0x%x" [expr 0x1002 + $i]] -prw -d16 -zx -i0x20"
      define-vme-register $name xVME Ch$ch.ADC_Header  "-a$A32addrbase -w32 -o[format "0x%x" [expr 0x1004 + $i]] -prw -d16 -zx"
      define-vme-register $name xVME Ch$ch.ADC_Trigger "-a$A32addrbase -w32 -o[format "0x%x" [expr 0x1006 + $i]] -prw -d16 -zx"
      define-vme-register $name xVME Ch$ch.ADC_Spare3  "-a$A32addrbase -w32 -o[format "0x%x" [expr 0x1008 + $i]] -prw -d16 -zx"
      define-vme-register $name xVME Ch$ch.ADC_Spare4  "-a$A32addrbase -w32 -o[format "0x%x" [expr 0x100a + $i]] -prw -d16 -zx"

      incr i 0x4000
   }
}


proc {GRT 4P_registers} {} {
    global registers_table

    set registers_table   {}

    foreach c {A B C D} {
        lappend registers_table [list "Channel $c Data FIFO"  Ch$c.DataFiFo]
        lappend registers_table [list "Channel $c DPP CSR"  Ch$c.DPP_CSR]
        lappend registers_table [list "Channel $c DPP Write Pointer"  Ch$c.DPP_Wptr]
        lappend registers_table [list "Channel $c DPP Read Pointer"  Ch$c.DPP_Rptr]
        for {set i 4} {$i <= 6} {incr i} {
            lappend registers_table [list "Channel $c DPP Reg$i"   Ch$c.DPP_Reg$i]
        }
        lappend registers_table [list "Channel $c ADC CTRL"  Ch$c.ADC_Ctrl]
        lappend registers_table [list "Channel $c ADC Pretrig"  Ch$c.ADC_PreTrig]
        lappend registers_table [list "Channel $c ADC Header"  Ch$c.ADC_Header]
        lappend registers_table [list "Channel $c ADC Trigger" Ch$c.ADC_Trigger]
        lappend registers_table [list "Channel $c ADC Spare3"  Ch$c.ADC_Spare3]
        lappend registers_table [list "Channel $c ADC Spare4"  Ch$c.ADC_Spare4]
    }
}


proc {GRT 4P_DAQ-reset} {args} {
#   grt4p
    global CurrentVMEServer
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]
#    soft reset
    write-vme-registers $module.Ch\[A-D\].ADC_Ctrl 1
    write-vme-registers $module.Ch\[A-D\].ADC_Ctrl 0
    set m [second [split $module #]]
    write-vme-register $module.ChA.ADC_Header  [expr (($m << 2) + 0) << 8]
    write-vme-register $module.ChB.ADC_Header  [expr (($m << 2) + 1) << 8]
    write-vme-register $module.ChC.ADC_Header  [expr (($m << 2) + 2) << 8]
    write-vme-register $module.ChD.ADC_Header  [expr (($m << 2) + 3) << 8]
}

proc {GRT 4P_DAQ-go} {args} {
#   grt4p
    global CurrentVMEServer
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]
    write-vme-registers $module.Ch\[A-D\].ADC_Trigger 0x100
    foreach c {A B C D} {
       set csr [read-vme-register $module.Ch$c.DPP_CSR]
       if {[expr $csr & 0x80] != 0x80} {
           write-vme-register $module.Ch$c.ADC_Ctrl 0x22
       } else {
           write-vme-register $module.Ch$c.ADC_Ctrl 0x20
       }
    }
}

proc {GRT 4P_DAQ-halt} {args} {
#   grt4p
    global CurrentVMEServer
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]
    write-vme-registers $module.Ch\[A-D\].ADC_Ctrl 0
}

proc {GRT 4P_DAQ-setup} {args} {
#   grt4p
    global CurrentVMEServer
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]
#    soft reset
    write-vme-registers $module.Ch\[A-D\].ADC_Ctrl 1
    write-vme-registers $module.Ch\[A-D\].ADC_Ctrl 0
    initialise-vme-registers $module.Ch\[A-D\].DPP_CSR
    initialise-vme-registers $module.Ch\[A-D\].ADC_PreTrig
    initialise-vme-registers $module.Ch\[A-D\].ADC_Ctrl
    write-vme-registers $module.Ch\[A-D\].DPP_Reg5 0xef
    set m [second [split $module #]]
    write-vme-register $module.ChA.ADC_Header  [expr (($m << 2) + 0) << 8]
    write-vme-register $module.ChB.ADC_Header  [expr (($m << 2) + 1) << 8]
    write-vme-register $module.ChC.ADC_Header  [expr (($m << 2) + 2) << 8]
    write-vme-register $module.ChD.ADC_Header  [expr (($m << 2) + 3) << 8]
}

#   for parameter save/restore
set {GRT 4P_registersavepatterns} {Ch\[A-D\].DPP_CSR Ch\[A-D\].ADC_PreTrig Ch\[A-D\].ADC_Trigger}


