#
#  for UCL/GRT adds timed runs. SCL,  08 Dec 03 

set UCL 0

if {$UCL} then {

set runtime 0
set runafterid ""

proc at-ucl-click-da {v} {
        global debug env VERSION RDOUTstate RDOUThdwre RDOUTEnable TSEnable CAMACEnable VMEEnable VXIEnable
        if {$debug} then {puts stderr "setting MIDAS DA to state $v"}

#    First check that the servers have been configured - that is registers for the installed hardware have been created
#    This is performed when the server is installed for VXI

    if {$VMEEnable != 0 && [inform vmecontrol HasBeenConfigured] == 0} then {
         midas-warning "The VME server has not been configured\nIt may recently have been restarted\nUse SETUP first"
         return -1
    }

    if {$CAMACEnable != 0 && [inform camaccontrol HasBeenConfigured] == 0} then {
         midas-warning "The CAMAC server has not been configured\nIt may recently have been restarted\nUse SETUP first"
         return -1
    }

#    Now if the action is GO ensure that a parameter restore has been performed

    if {$v == 1} {

    if {$CAMACEnable != 0 && [inform camacsaverestore HasBeenRestored] == 0} then {
         set r [midas-confirmation "You have not performed a parameter restore for the CAMAC server\nIt may recently have been restarted\n\
                          Do you wish to continue or to abort so that you can SETUP first"]
         if {$r == 0} then {return -1}
    }

    if {$VMEEnable != 0 && [inform vmesaverestore HasBeenRestored] == 0} then {
         set r [midas-confirmation "You have not performed a parameter restore for the VME server\nIt may recently have been restarted\n\
                          Do you wish to continue or to abort so that you can SETUP first"]
         if {$r == 0} then {return -1}
    }

    if {$VXIEnable != 0 && [inform vxicontrol VXI-ResetState] == 0} then {
         set r [midas-confirmation "The VXI control software has NOT performed a software reset\n\
               for one or more VXI servers\nIt may recently have been restarted\n\
               Your VXI hardware may not operate correctly unless this is done.\n\
               Do you wish to continue or to abort so that you can SETUP first"]
         if {$r == 0} then {return -1}
    }

    if {$VXIEnable != 0 && [inform vxicontrol VXI-RestoreState] == 0} then {
         set r [midas-confirmation "You have not performed a parameter restore for one or more VXI servers\nIt may recently have been restarted\n\
                          Do you wish to continue or to abort so that you can SETUP first"]
         if {$r == 0} then {return -1}
    }

    }

     if {$RDOUTEnable != 0} then {set RDOUTstate $v}
    set z [catch {
        if {$v==0} then {
            set-footer "STOPping MIDAS DA [date]"
                Custom_PreStop
                Stop_Electronics
                click-vxi 0
                click-camac 0
                click-vme 0
                click-rdout 0
                click-tapes 0
            set-footer "MIDAS DA STOPped [date]"
            insert-log "sys: [date] Data Acquisition STOPPED"
         }
         if {$v==1} then {
            if {$RDOUTEnable != 0} then {
                set state [read-register $RDOUThdwre.Sstate]
                if {$state == 2} then {
                    midas-warning "Data Acquisition is already running - Use STOP first"
                    return -1
                }
            }
            set-footer "GOing MIDAS DA [date]"
                if {$TSEnable != 0} then {
                    if {[send tape read-storagestate] != 0} then {
                         set r [midas-confirmation "Tape Server is in No Storage state\n\
                                Do you wish to continue or to abort so that you can change this"]
                         if {$r == 0} then {return -1}
                    }
                    click-tapes 1
                    if {[send tape read-egstate] != 1} then {
                         set r [midas-confirmation "Tape Server not in Going state\n\
                                Do you wish to continue or to abort so that you can correct the problem"]
                         if {$r == 0} then {return -1}
                    }
                }
                Reset_Electronics
                if {$VERSION == "GRT4P"} then {click-vme 2}
                if {$RDOUTEnable != 0} then {
                    click-rdout 3
                    click-rdout 1
                    if {[read-register $RDOUThdwre.Sstate] != 2} then {
                         midas-warning "Data Acquisition Program not in Going state\n\GO aborted"
                         return -1
                    }
                }
                click-vme 1
                click-camac 1
                click-vxi 1
                Go_Electronics
                Custom_PostGo
            set-footer "MIDAS DA GOing [date]"
            insert-log "sys: [date] Data Acquisition GOING"
         }
     } m ]

   set footertext $env(FooterText)
   click-redisplay
   set-footer $footertext

    return [da_state]
}

proc at-ucl-make-frame {} {
  global env RDOUThdwre actionlist
  global VERSION CAMACPresent VMEPresent VXIPresent X2VBPresent
  global HistMode
  global CAMACEnable VMEEnable VXIEnable 
  global RDOUTEnable TSPresent EBPresent
  global RISING


  :frame [self frame-name] :label "[self frame-title]" :show-footer T \
      :icon-image "@$env(ICONHOME)/default" \
      :icon-name "[self icon-title]" :resize F

   :container P1 :layout T
    :layout H; :row-gap 10; :col-gap 10

   :panel P1A :layout L :padx 10 :pady 10
    :layout H; :row-gap 10; :col-gap 10

if {$CAMACPresent == 1} {
      :choice CAMAC :label Camac: :strings [list Stop Go] :valuex 14c :value -1
      :checkbox CAMACENABLE :label "" :value $CAMACEnable
      :next-row T
      lappend actionlist "\"CAMAC Reset\" \"click-camac 2\""
   if {$X2VBPresent == 1} {
      lappend actionlist "\"Zero X2VB RAM\" \"click-zero\""
      lappend actionlist "\"Format X2VB RAM\" \"click-format\""
      lappend actionlist "\"Force X2VB Read Out\" \"RdOut_Enable 1\""
      lappend actionlist "\"Normal X2VB Read Out\" \"RdOut_Enable 0\""
   }

}
if {$VMEPresent == 1} {
      :choice VME :label VME: :strings [list Stop Go] :valuex 14c :value -1
      :checkbox VMEENABLE :label "" :value $VMEEnable
      :next-row T
      lappend actionlist "\"VME Reset\" \"click-vme 2\""
}
if {$VXIPresent == 1} {
      :choice VXI :label VXI: :strings [list Stop Go] :valuex 14c :value -1
      :checkbox VXIENABLE :label "" :value $VXIEnable
      :next-row T
      lappend actionlist "\"Pause VXI\" \"click-vxipause 1\""     
      lappend actionlist "\"Resume VXI\" \"click-vxipause 0\""
      lappend actionlist "\"VXI Reset\" \"click-vxi 3\""
      lappend actionlist "\"VXI Setup\" \"click-vxi 4\""
      lappend actionlist "\"Ignore Null Events\" \"Null_Events 1\""
      lappend actionlist "\"Keep Null Events\" \"Null_Events 0\""
   if {$X2VBPresent == 1} {
      lappend actionlist "\"Zero X2VB RAM\" \"click-zero\""
      lappend actionlist "\"Format X2VB RAM\" \"click-format\""
      lappend actionlist "\"Force X2VB Read Out\" \"RdOut_Enable 1\""
      lappend actionlist "\"Normal X2VB Read Out\" \"RdOut_Enable 0\""
   }
}

if {$RDOUThdwre != "VME"} then {
      :choice RDOUT :label [set RDOUThdwre]: :strings [list Stop Go] :valuex 14c :value -1
      lappend actionlist "\"[set RDOUThdwre] Setup\" \"click-rdout 2\""
      lappend actionlist "\"[set RDOUThdwre] Reset\" \"click-rdout 3\""
} else {
      :choice RDOUT :label Readout: :strings [list Stop Go] :valuex 14c :value -1
      lappend actionlist "\"Readout Setup\" \"click-rdout 2\""
      lappend actionlist "\"Readout Reset\" \"click-rdout 3\""
}

      :checkbox RDOUTENABLE :label "" :value $RDOUTEnable

      :row-gap 20; :next-row T
      :number RUNTIME :label "Run Time (s)" :w 6 :min 0 :max 500 :command do-runtime

   :panel P1B :layout L :padx 10 :pady 10
    :layout H; :row-gap 10; :col-gap 10

      :button  DA-STOP  :label  STOP  :w 8 :h 3 :colour red
      :hskip 30
      :button  DA-GO    :label  GO    :w 8 :h 3 :colour green
      :next-row T
      :button DA-SETUP  :label SETUP  :w 26 :h 2 :colour yellow :command "click-setup 0"

  :container end

   :panel P2 :layout T :padx 10 :pady 10
    :layout H; :row-gap 10; :col-gap 20

      :checkbox HISTENABLE :label "Histogramming Enabled"    :value 0  :valuex 20c
      if {$VERSION != "D2VB" && $VERSION != "GREAT"} then {
         if {$VERSION == "Megha"} {set HistChoices [list None E T E&T]}
         if {$VERSION != "Megha"} {set HistChoices [list None All]}
         :choice HISTMODE :label Histogram :strings $HistChoices :command click-histmode :value $HistMode
      } else {
         :button HIST :label "Histogram Setup" :command "send shist start"
      }
      
      if {$VERSION == "Megha" || $VERSION == "Charissa" || $VERSION == "TUDA"} {
         :menubutton SCALERS :label "Scalers" :strings [list Show Clear]
      }

      :next-row T
      :col-gap 10

if {[info exists RISING]} then {
      :text TRIGRATE    :label "Master Trigger Rate (/sec)" :w 6 :deaf T :valuex 22c
      :text EVENTRATE   :label "Accepted Event Rate (/sec)" :w 6 :deaf T :valuex 23c
      :next-row T

       :text TSSERVER      :label "MBS Server"  :w 8 :command do_tsserver
       :text TSPORT        :label "Port"        :w 5  :command do_tsport
       :button TSDEFINE    :label "Setup Connection"  :command do_tsdefine
       :button TSUNDEFINE  :label "End Connection" :command do_tsundefine

      :next-row T
      :checkbox TXACTIVE :label "MBS Connected" :deaf T
      :checkbox TXENABLE :label "MBS Transfer Enabled" :value 0
      :text TXRATE :label "Data Rate (Kbytes/sec)" :w 6 :deaf T
} else {

if {$TSPresent != 0} {
      :checkbox TXENABLE   :label "TS Transfer Enabled"  :value 0  :valuex 20c
}
if {$EBPresent != 0} {
      :checkbox EBTXENABLE :label "EB Transfer Enabled"  :value 0  :valuex 20c
}
if {$TSPresent != 0 || $EBPresent != 0} then {:next-row T}

if {$TSPresent} then {
     :choice TAPE :label Tapes: :strings [list Stop Go] :valuex 14c
     :checkbox TSENABLE   :label "Tape Server Enabled"  :value 0

      :button TAPECONTROL :label "Tape Control" :command "inform tape start"
      :next-row T
      :text STREAM  :label "Tapes in Use" :w 30 :deaf T
      :text RUN     :label "Run Number" :w 8 :deaf T  :value "unknown" 
      :next-row T
      :text RATE    :label "Tape Rate (Kbytes/sec)" :w 6 :deaf T
      :text PERCENT :label "Tape Used (%)" :w 6 :deaf T
}

}


if {$VERSION == "TAS"} {
      :next-row T
      :button HM413 :label "Update HM413 Histograms" :command click-HM413ReadOut
}

   :panel P3 :layout B :padx 10 :pady 10 :after FOOTER
    :layout H; :row-gap 10; :col-gap 5
      :button REDISPLAY    :label Redisplay
      :menubutton MONITOR      :label Monitoring  :strings [list Statistics Monitoring]
      :menubutton SPECTRA      :label Spectra     :strings [list "Spectrum Browser"  "Spectrum Viewer"]
      :button REGISTERS :label "Setup Registers" :command make-registers
      set menu {}
      foreach item $actionlist {lappend menu [first $item]}
      :menubutton ACTIONS :label "Advanced"  :strings $menu

   :show T

}

proc do-runtime {w v} {
	global runtime
	set runtime $v
}

proc Custom_PostGo {} {
        global runtime runafterid
	if {$runafterid != ""} {after cancel $runafterid}
	if {$runtime} {set runafterid [after [expr $runtime * 1000] click-da 0]}
}

proc Custom_PreStop {} {
        global runtime runafterid
	if {$runafterid != ""} {after cancel $runafterid; set runafterid ""}
}

}
